// Copyright (c) .NET Foundation. All rights reserved.
// Licensed under the Apache License, Version 2.0. See License.txt in the project root for license information.

// This file is used by Code Analysis to maintain SuppressMessage
// attributes that are applied to this project.
// Project-level suppressions either have no target or are given
// a specific target and scoped to a namespace, type, member, etc.

using System.Diagnostics.CodeAnalysis;

[assembly: SuppressMessage("Build", "CA1062:In externally visible method 'void MSBuildLogger.Log(ILogMessage message)', validate parameter 'message' is non-null before using it. If appropriate, throw an ArgumentNullException when the argument is null or add a Code Contract precondition asserting non-null argument.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.MSBuildLogger.Log(NuGet.Common.ILogMessage)")]
[assembly: SuppressMessage("Build", "CA1822:Member LogError does not access instance data and can be marked as static (Shared in VisualBasic)", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.MSBuildLogger.LogError(NuGet.Common.INuGetLogMessage,NuGet.Build.MSBuildLogger.LogErrorWithDetails,NuGet.Build.MSBuildLogger.LogErrorAsString)")]
[assembly: SuppressMessage("Build", "CA1822:Member LogMessage does not access instance data and can be marked as static (Shared in VisualBasic)", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.MSBuildLogger.LogMessage(NuGet.Common.INuGetLogMessage,Microsoft.Build.Framework.MessageImportance,NuGet.Build.MSBuildLogger.LogMessageWithDetails,NuGet.Build.MSBuildLogger.LogMessageAsString)")]
[assembly: SuppressMessage("Build", "CA1031:Modify 'Execute' to catch a more specific allowed exception type, or rethrow the exception.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.Pack.PackTask.Execute~System.Boolean")]
[assembly: SuppressMessage("Build", "CA1303:Method 'bool PackTask.Execute()' passes a literal string as parameter 'value' of a call to 'void Console.WriteLine(string value)'. Retrieve the following string(s) from a resource table instead: \"Waiting for debugger to attach.\".", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.Pack.PackTask.Execute~System.Boolean")]
[assembly: SuppressMessage("Build", "CA1062:In externally visible method 'void PackTaskLogic.BuildPackage(PackCommandRunner runner)', validate parameter 'runner' is non-null before using it. If appropriate, throw an ArgumentNullException when the argument is null or add a Code Contract precondition asserting non-null argument.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.Pack.PackTaskLogic.BuildPackage(NuGet.Commands.PackCommandRunner)")]
[assembly: SuppressMessage("Build", "CA1822:Member GetContentMetadata does not access instance data and can be marked as static (Shared in VisualBasic)", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.Pack.PackTaskLogic.GetContentMetadata(NuGet.Commands.IMSBuildItem,System.String,NuGet.Commands.PackArgs,System.String[])~System.Collections.Generic.IEnumerable{NuGet.Commands.ContentMetadata}")]
[assembly: SuppressMessage("Build", "CA1062:In externally visible method 'PackageBuilder PackTaskLogic.GetPackageBuilder(IPackTaskRequest<IMSBuildItem> request)', validate parameter 'request' is non-null before using it. If appropriate, throw an ArgumentNullException when the argument is null or add a Code Contract precondition asserting non-null argument.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.Pack.PackTaskLogic.GetPackageBuilder(NuGet.Build.Tasks.Pack.IPackTaskRequest{NuGet.Commands.IMSBuildItem})~NuGet.Packaging.PackageBuilder")]
[assembly: SuppressMessage("Build", "CA1062:In externally visible method 'PackArgs PackTaskLogic.GetPackArgs(IPackTaskRequest<IMSBuildItem> request)', validate parameter 'request' is non-null before using it. If appropriate, throw an ArgumentNullException when the argument is null or add a Code Contract precondition asserting non-null argument.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.Pack.PackTaskLogic.GetPackArgs(NuGet.Build.Tasks.Pack.IPackTaskRequest{NuGet.Commands.IMSBuildItem})~NuGet.Commands.PackArgs")]
[assembly: SuppressMessage("Build", "CA1062:In externally visible method 'PackCommandRunner PackTaskLogic.GetPackCommandRunner(IPackTaskRequest<IMSBuildItem> request, PackArgs packArgs, PackageBuilder packageBuilder)', validate parameter 'request' is non-null before using it. If appropriate, throw an ArgumentNullException when the argument is null or add a Code Contract precondition asserting non-null argument.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.Pack.PackTaskLogic.GetPackCommandRunner(NuGet.Build.Tasks.Pack.IPackTaskRequest{NuGet.Commands.IMSBuildItem},NuGet.Commands.PackArgs,NuGet.Packaging.PackageBuilder)~NuGet.Commands.PackCommandRunner")]
[assembly: SuppressMessage("Build", "CA1822:Member GetSourcePath does not access instance data and can be marked as static (Shared in VisualBasic)", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.Pack.PackTaskLogic.GetSourcePath(NuGet.Commands.IMSBuildItem)~System.String")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.GetPackOutputItemsTask.OutputPackItems")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.GetProjectReferencesFromAssetsFileTask.ProjectReferences")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.AllowedOutputExtensionsInPackageBuildOutputFolder")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.AllowedOutputExtensionsInSymbolsPackageBuildOutputFolder")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.Authors")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.BuildOutputFolders")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.BuildOutputInPackage")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.ContentTargetFolders")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.FrameworkAssemblyReferences")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.FrameworksWithSuppressedDependencies")]
[assembly: SuppressMessage("Build", "CA1056:Change the type of property IPackTaskRequest<TItem>.IconUrl from string to System.Uri.", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.IconUrl")]
[assembly: SuppressMessage("Build", "CA1056:Change the type of property IPackTaskRequest<TItem>.LicenseUrl from string to System.Uri.", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.LicenseUrl")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.NuspecProperties")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.PackageFiles")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.PackageFilesToExclude")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.PackageTypes")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.ProjectReferencesWithVersions")]
[assembly: SuppressMessage("Build", "CA1056:Change the type of property IPackTaskRequest<TItem>.ProjectUrl from string to System.Uri.", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.ProjectUrl")]
[assembly: SuppressMessage("Build", "CA1056:Change the type of property IPackTaskRequest<TItem>.RepositoryUrl from string to System.Uri.", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.RepositoryUrl")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.SourceFiles")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.Tags")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.TargetFrameworks")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.IPackTaskRequest`1.TargetPathsToSymbols")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.AllowedOutputExtensionsInPackageBuildOutputFolder")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.AllowedOutputExtensionsInSymbolsPackageBuildOutputFolder")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.Authors")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.BuildOutputFolders")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.BuildOutputInPackage")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.ContentTargetFolders")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.FrameworkAssemblyReferences")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.FrameworksWithSuppressedDependencies")]
[assembly: SuppressMessage("Build", "CA1056:Change the type of property PackTask.IconUrl from string to System.Uri.", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.IconUrl")]
[assembly: SuppressMessage("Build", "CA1056:Change the type of property PackTask.LicenseUrl from string to System.Uri.", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.LicenseUrl")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.NuspecProperties")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.PackageFiles")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.PackageFilesToExclude")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.PackageTypes")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.ProjectReferencesWithVersions")]
[assembly: SuppressMessage("Build", "CA1056:Change the type of property PackTask.ProjectUrl from string to System.Uri.", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.ProjectUrl")]
[assembly: SuppressMessage("Build", "CA1056:Change the type of property PackTask.RepositoryUrl from string to System.Uri.", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.RepositoryUrl")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.SourceFiles")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.Tags")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.TargetFrameworks")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTask.TargetPathsToSymbols")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.AllowedOutputExtensionsInPackageBuildOutputFolder")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.AllowedOutputExtensionsInSymbolsPackageBuildOutputFolder")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.Authors")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.BuildOutputFolders")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.BuildOutputInPackage")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.ContentTargetFolders")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.FrameworkAssemblyReferences")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.FrameworksWithSuppressedDependencies")]
[assembly: SuppressMessage("Build", "CA1056:Change the type of property PackTaskRequest.IconUrl from string to System.Uri.", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.IconUrl")]
[assembly: SuppressMessage("Build", "CA1056:Change the type of property PackTaskRequest.LicenseUrl from string to System.Uri.", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.LicenseUrl")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.NuspecProperties")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.PackageFiles")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.PackageFilesToExclude")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.PackageTypes")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.ProjectReferencesWithVersions")]
[assembly: SuppressMessage("Build", "CA1056:Change the type of property PackTaskRequest.ProjectUrl from string to System.Uri.", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.ProjectUrl")]
[assembly: SuppressMessage("Build", "CA1056:Change the type of property PackTaskRequest.RepositoryUrl from string to System.Uri.", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.RepositoryUrl")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.SourceFiles")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.Tags")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.TargetFrameworks")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.Pack.PackTaskRequest.TargetPathsToSymbols")]
